<?php

namespace Smartlink\Checkout\Block\Adminhtml;

use Magento\Backend\Block\Template;

class ConfigData extends Template
{
    protected $_scopeConfig;

    public function __construct(
        Template\Context $context,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->_scopeConfig = $scopeConfig;
    }

    public function getConfigValue($path)
    {
        return $this->_scopeConfig->getValue($path, \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
    }

    public function getConfigData(){   // store merchant data

        // Fetch data from the core_config_data table
        $path = 'section/group/field'; // Replace with the actual configuration path
        $configArray = array(
            "merchant_id"=>$this->getConfigValue('payment/smartlink_checkout/marchant_id'),
            "web_id"=>$this->getConfigValue('payment/smartlink_checkout/web_id'),
            "email"=>$this->getConfigValue('payment/smartlink_checkout/merchant_email'),
            "name"=>$this->getConfigValue('payment/smartlink_checkout/merchant_name'),
            "profile_pic"=>$this->getConfigValue('payment/smartlink_checkout/merchant_image'),
            "platform"=>$this->getConfigValue('payment/smartlink_checkout/platform'),
            "fiat_currency"=>$this->getConfigValue('payment/smartlink_checkout/fiat_currency'),
            "redirect_url"=>$this->getConfigValue('payment/smartlink_checkout/redirect_url'),
            "whitelist_ip"=>$this->getConfigValue('payment/smartlink_checkout/whitelist_ip'),
            "api_key"=>$this->getConfigValue('payment/smartlink_checkout/api_key'),
        );
        return $configArray;
    }
}
