<?php

namespace Smartlink\Checkout\Controller\Invoice;
use Zend\Http\Request;


class Webhook extends \Magento\Framework\App\Action\Action {
  
	protected $apiCall;
   protected $orderManagement;
   protected $_scopeConfig;

   public function __construct(
      \Magento\Framework\App\Action\Context $context,
      \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
      \Smartlink\Checkout\Model\Api\Api $apiCall,
      \Magento\Sales\Api\OrderManagementInterface $orderManagement,
      \Magento\Catalog\Api\ProductRepositoryInterface $productRepository,
      \Magento\Sales\Model\Service\InvoiceService $invoiceService
   ){
      
      $this->apiCall = $apiCall;
      $this->orderManagement = $orderManagement;
      $this->_scopeConfig = $scopeConfig;
      parent::__construct($context);
      $this->productRepository = $productRepository;
      $this->_invoiceService = $invoiceService;
   }

   public function execute(){ // receive webhook and process transsaction


      // dd($this->getRequest()->getParam('txid'));
   	if ($this->getRequest()->getParam('txid') && $this->getRequest()->getParam('order_id') != "" && $this->getRequest()->getParam('confirmations') != "") {

         $order_id = $this->getRequest()->getParam('order_id');
         $trx_id = $this->getRequest()->getParam('txid');
         $status = $this->getRequest()->getParam('status');
         $user_id = $this->getRequest()->getParam('user_id');
         $crypto_amount = $this->getRequest()->getParam('crypto_amount');
         $crypto_currency = $this->getRequest()->getParam('crypto_currency');
         $fiat_amount = $this->getRequest()->getParam('fiat_amount');
         $fiat_currency = $this->getRequest()->getParam('fiat_currency');
         $webhook_type = $this->getRequest()->getParam('type');
         $explorer_url = $this->getRequest()->getParam('explorer_url');
         $paid_date = $this->getRequest()->getParam('date');
         $confirmations = $this->getRequest()->getParam('confirmations');

         $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
         $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
         $connection = $resource->getConnection();
         $sql = "SELECT * FROM smartlink_payments WHERE order_id= '".$order_id."'";

         $sql = "UPDATE smartlink_payments SET status='".$status."',trx_id='".$trx_id."',user_id='".$user_id."',crypto_amount='".$crypto_amount."',crypto_currency='".$crypto_currency."',fiat_amount='".$fiat_amount."',fiat_currency='".$fiat_currency."'  WHERE order_id= '".$order_id."'";
         $updatePayment = $connection->query($sql);
         $webhook_data = [
            $order_id,
            $trx_id,
            $webhook_type,
            $explorer_url,
            $crypto_amount,
            $crypto_currency,
            $paid_date,
            $confirmations,
         ];
         $this->dataInsertDB($webhook_data);
         if($status == 1){
            $this->orderConfirm($order_id);
         }
         $msg = "success";
      } else {
        $msg = "Parameter Not Found";
        return $this->getResponse()->setBody($msg);
      }
      return $this->getResponse()->setBody($msg);
   }

   public function CR_get_transaction($param){

      $api_base_url = $this->apiCall->getApiUrl();
      $data = $param;
      $url =  $api_base_url."/".$data['coin']."/get-transaction";
      
      $res = $this->apiCall->apiCaller($url, Request::METHOD_POST,$data);
      return $res;
   }

   public function dataInsertDB($_data){

      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
      $connection = $resource->getConnection();
         //$result = $connection->insertForce($_table,$_data);

      $sql = "INSERT INTO smartlink_webhooks SET order_id=?, trx_id=?, type=?, explorer_url=?, paid_amount=?,paid_currency=?, paid_date=?, confirmations=?";
      $connection->query($sql, $_data);
      $lastInsertId = $connection->lastInsertId();
   }

   public function getOrder($_order_id){

      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $order = $objectManager->create('Magento\Sales\Api\Data\OrderInterface')->load($_order_id);
      return $order;

   }

   public function orderConfirm($_order_id)
   {
      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $orders = $objectManager->create('\Magento\Sales\Model\Order')->load($_order_id);
      $orders->setStatus('complete');
      $orders->save();
      $this->downloadableOrder($_order_id);
   }

   public function orderCancel($_order_id)
   {
      $this->orderManagement->cancel($_order_id);
   }

   public function getStoreConfig($_env){
      $_val = $this->_scopeConfig->getValue(
         $_env, \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
      return $_val;
   }

   public function downloadableOrder($orderId)
   {
      $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
      $order = $objectManager->create('Magento\Sales\Api\Data\OrderInterface')->load($orderId);
      $orderItems = $order->getAllItems();
      $isDownloadableType = null;
      foreach ($orderItems as $item) {
         $product = $this->productRepository->get($item->getSku());
         if ($product->getTypeId() === \Magento\Downloadable\Model\Product\Type::TYPE_DOWNLOADABLE) {
            $isDownloadableType = true; 
            break;
         }
      }
      if($isDownloadableType){
         $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
         $connection = $resource->getConnection();
         $status = \Magento\Downloadable\Model\Link\Purchased\Item::LINK_STATUS_AVAILABLE;
         $sql = "UPDATE downloadable_link_purchased_item SET status='$status' WHERE purchased_id IN (SELECT purchased_id FROM downloadable_link_purchased WHERE order_id=$orderId)";
         $result = $connection->query($sql);
      }
   }

}