<?php

namespace Smartlink\Checkout\Observer;

use Magento\Framework\Event\ObserverInterface;
use Smartlink\Checkout\Model\Api\Api;
use Magento\Framework\HTTP\ZendClientFactory;
use Zend\Http\Request;
use Magento\Backend\App\Action\Context;
use Magento\Framework\Controller\ResultFactory;
// class Config extends \Magento\Framework\App\Action\Action implements ObserverInterface
class Config implements ObserverInterface
{
    /**
     * payment_method_is_active event handler.
     *
     * @param \Magento\Framework\Event\Observer $observer
     */
    protected $apiCall;
    protected $_scopeConfig;
    protected $_resourceConfig;
    protected $_messageManager;
    protected $_resultFactory;
    protected $_redirect;
    public function __construct(
        Context $context,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Smartlink\Checkout\Model\Api\Api $apiCall,
        \Magento\Config\Model\ResourceModel\Config $resourceConfig,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        \Magento\Framework\Controller\ResultFactory $resultFactory,
        \Magento\Framework\App\Response\RedirectInterface $redirect
    ) {
        $this->_scopeConfig = $scopeConfig;
        $this->apiCall = $apiCall;
        $this->_resourceConfig = $resourceConfig;
        $this->_messageManager = $messageManager;
        $this->_resultFactory = $resultFactory;
        $this->_redirect = $redirect;
    }
    public function getStoreConfig($_env)
    {
        $_val = $this->_scopeConfig->getValue(
            $_env, \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            // dd($_val);
        return $_val;

    }
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        // dd($observer->getEvent()->getData());
        $data = $observer->getEvent()->getData();
        // dd($data['changed_paths']);
        $merchant_id = '';
        $api_key = '';
        // foreach ($data['changed_paths'] as $value) {
        //     if(!($value == 'payment/smarlink_checkout/marchant_id' || $value == 'payment/smarlink_checkout/api_key'))
        //         continue;

        //     }

        $merchant_id = $this->getStoreConfig('payment/smartlink_checkout/marchant_id');
        $api_key = $this->getStoreConfig('payment/smartlink_checkout/api_key');    
        if($merchant_id != null || $api_key != null){
            $webhook = $this->getBaseUrl()."smartlink/invoice/webhook";
            $validationData = array(
                "merchant_id"=>$merchant_id,
                "api_key"=>$api_key,
                'webhook_url'=>$webhook
            );
            $checkMerchant = $this->validate_merchant_data($validationData);
            if($checkMerchant['flag']==1){
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/web_id',$checkMerchant['data']['web_id'],'default',0,
                    'payment/smartlink_checkout/merchant_email',$checkMerchant['data']['email'],'default',0,
                    'payment/smartlink_checkout/merchant_name',$checkMerchant['data']['merchant_name'],'default',0,
                    'payment/smartlink_checkout/merchant_image',$checkMerchant['data']['merchant_image'],'default',0,
                    'payment/smartlink_checkout/platform',$checkMerchant['data']['platform'],'default',0,
                    'payment/smartlink_checkout/fiat_currency',$checkMerchant['data']['fiat_currency'],'default',0,
                    'payment/smartlink_checkout/redirect_url',$checkMerchant['data']['redirect_url'],'default',0,
                    'payment/smartlink_checkout/whitelist_ip',$checkMerchant['data']['whitelist_domain'],'default',0,
                );
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/merchant_email',$checkMerchant['data']['email'],'default',0,
                );
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/merchant_name',$checkMerchant['data']['merchant_name'],'default',0,
                );
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/merchant_image',$checkMerchant['data']['merchant_image'],'default',0,
                );
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/platform',$checkMerchant['data']['platform'],'default',0,
                );
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/fiat_currency',$checkMerchant['data']['fiat_currency'],'default',0,
                );
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/redirect_url',$checkMerchant['data']['redirect_url'],'default',0,
                );
                $this->_resourceConfig->saveConfig(
                    'payment/smartlink_checkout/whitelist_ip',$checkMerchant['data']['whitelist_domain'],'default',0,
                );
            }
            // else{
            //     // $this->_messageManager->addErrorMessage($checkMerchant['msg']);
            //     $this->_messageManager->addError($checkMerchant['msg']);
            //     // $resultRedirect = $this->_resultFactory->create(ResultFactory::TYPE_REDIRECT);
            //     // $resultRedirect->setUrl($this->_redirect->getRefererUrl());
            //     $resultRedirect = $this->_redirect->getRefererRedirect();
            //     return $resultRedirect;
            // }
        }
    }

    public function getBaseUrl(){

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        return $storeManager->getStore()->getBaseUrl();
    }

    public function validate_merchant_data($param){

        $api_base_url = $this->apiCall->getApiUrl();
        $data = $param;
        $url =  $api_base_url."/verify-merchant-account";
        $res = $this->apiCall->apiCaller($url, Request::METHOD_POST,$data);
        return $res;
    }

    public function dataInsertDB($_table, $_data){

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
        $connection = $resource->getConnection();
        $connection->insertForce($_table,$_data);
    }
}
