/**
 * Copyright © 2015 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
 /*browser:true*/
 /*global define*/
 define(
    [
    'Magento_Checkout/js/view/payment/default',
    ],
    function (Component) {
        'use strict';

        return Component.extend({
            defaults: {
                template: 'Smartlink_Checkout/payment/form',
                transactionResult: ''
            },

            /** Returns send check to info */
            getMailingAddress: function() {
                console.log('getMailingAddress')
                return window.checkoutConfig.payment.checkmo.mailingAddress;
            },
            initObservable: function () {
                console.log('initObservable')
                this._super()
                .observe([
                    'transactionResult'
                    ]);
                return this;
            },

            getCode: function() {
                console.log('getCodesad')
                return 'smartlink_checkout';
            },

            getData: function() {
                console.log('getData')
                return {
                    'method': this.item.method,
                    'additional_data': {
                        'transaction_result': this.transactionResult()
                    }
                };
            },

            getTransactionResults: function() {
                console.log('getTransactionResults');
             return _.map(window.checkoutConfig.payment.sample_gateway.transactionResults, function(value, key) {
                return {
                    'value': value.coin,
                    'transaction_result': value.coin +' - '+value.coin_name
                }
            });
         },

         getDescription: function() {
            console.log('getDescription');
            return window.checkoutConfig.payment.sample_gateway.payment_description;
        },

        isWallets: function(){
            console.log('isWallets');
            console.log('window.checkoutConfig.payment.sample_gateway.isWallets',window.checkoutConfig.payment.sample_gateway.isWallets)
            return window.checkoutConfig.payment.sample_gateway.isWallets;   
        }
    });
    }
    );
